/*
*Filename: mylcd.h
*Author: Stanislav Subrt
*Year: 2013
*/

#ifndef MYLCD_H
#define MYLCD_H

#include "main.h"

#define LCD_INTERFACEPINS	(LCD_PIN_DI|LCD_PIN_RW|LCD_PIN_E|LCD_PIN_CS1|LCD_PIN_CS2|LCD_PIN_D0|LCD_PIN_D1|LCD_PIN_D2|LCD_PIN_D3|LCD_PIN_D4|LCD_PIN_D5|LCD_PIN_D6|LCD_PIN_D7)	//define lcd interface pins
#define LCD_DATAPINS		(LCD_PIN_D0|LCD_PIN_D1|LCD_PIN_D2|LCD_PIN_D3|LCD_PIN_D4|LCD_PIN_D5|LCD_PIN_D6|LCD_PIN_D7)		//define lcd data pins
#define LCD_CHIPSELPINS	(LCD_PIN_CS1|LCD_PIN_CS2)	//define chipselect pins
#define LCD_COMMANDPINS	(LCD_PIN_DI|LCD_PIN_RW|LCD_PIN_E)	//define command pins

#define LCD_WIDTH			128		//define screen width
#define LCD_HEIGHT		64		//define screen height
#define LCD_PAGES			8		//define number of screen y pages

#define LCD_SCREENBUFFERSIZE	1024



typedef struct{
	unsigned x;
	unsigned page;
} lcd_PositionTd;



extern void lcd_Init(void);
extern void lcd_SetOnOff(unsigned status);
extern void lcd_UpdateScreen(const char* screenBuffer);

extern void lcd_Fill(char* screenBuffer, char pattern);
extern void lcd_CopyBuffer(char* destBuffer, char* sourceBuffer);
extern lcd_PositionTd* lcd_PutChar(char* screenBuffer, char charToPut, lcd_PositionTd* charPositionStruct, int colorsInverted);
extern lcd_PositionTd* lcd_PutStr(char* screenBuffer, char* strToPut, int stringLength, lcd_PositionTd* firstCharPositionStruct, int colorsInverted);
extern void lcd_InvertPixels(char* screenBuffer, lcd_PositionTd* startPosStruct, lcd_PositionTd* endPosStruct);
extern void lcd_PlaceBackground(char* screenBuffer, lcd_PositionTd* startPosStruct, lcd_PositionTd* endPosStruct, int bgColor);

#endif  //end of MYLCD_H
