// Header:
// File Name:					main.h
// File Description:
// Author:						Stanislav Subrt
// Date:							2013
// Todo:
// Notes:

#ifndef	main_h
#define main_h

#include "stm32f37x.h"
#include "circbuffer.h"
#include "adc.h"
#include "comm.h"
#include "potmet.h"
#include "syndet.h"
#include "lcd.h"
#include "gui.h"
#include "buttons.h"

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>



#define VERSIONSTRING		"<CrackFinder based on PotMet v3.2>\r\n>"
#define DEVICENAMESTRING	"<CrackFinder Dev1>\r\n"


//////////////////////////////////////////////////////////////////////
////////// APERTURE RESPONSES ////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

#define MAIN_MEASRUNNING	"<Measurement in progress:"
#define MAIN_MEASCOMPLETE	"<Measurement complete!\r\n>"
#define MAIN_MEASARBORTED	"<Measurement arborted!\r\n>"
#define MAIN_APERTUREREADY	"<Aperture ready!\r\n>"




//////////////////////////////////////////////////////////////////////
////////// BOARD DEFINITIONS /////////////////////////////////////////
//////////////////////////////////////////////////////////////////////

//USART1
#define USART1_TXPIN    		GPIO_Pin_9
#define USART1_TXPINSOURCE  	GPIO_PinSource9
#define USART1_RXPIN    		GPIO_Pin_10
#define USART1_RXPINSOURCE 	 	GPIO_PinSource10
#define USART1_PORT     		GPIOA
#define USART1_PERIPH			USART1
#define USART1_PORTPERIPHCLK	RCC_AHBPeriph_GPIOA
#define USART1_PERIPHCLK		RCC_APB2Periph_USART1

//LCD DISPLAY -------------------
#define LCD_PORT		GPIOC
#define LCD_PIN_D0		GPIO_Pin_0
#define LCD_PIN_D1		GPIO_Pin_1
#define LCD_PIN_D2		GPIO_Pin_2
#define LCD_PIN_D3		GPIO_Pin_3
#define LCD_PIN_D4		GPIO_Pin_4
#define LCD_PIN_D5		GPIO_Pin_5
#define LCD_PIN_D6		GPIO_Pin_6
#define LCD_PIN_D7		GPIO_Pin_7
#define LCD_PIN_DI		GPIO_Pin_12
#define LCD_PIN_RW		GPIO_Pin_11
#define LCD_PIN_E		GPIO_Pin_10
#define LCD_PIN_CS1		GPIO_Pin_8
#define LCD_PIN_CS2		GPIO_Pin_9

//BUTTONS
#define BTNS_PORT		GPIOB
#define BTNS_PORTSRC	EXTI_PortSourceGPIOB
#define BTNS_PIN_B0		GPIO_Pin_0
#define BTNS_PIN_B1		GPIO_Pin_1
#define BTNS_PIN_B2		GPIO_Pin_2
#define BTNS_SRC_B0		EXTI_PinSource0
#define BTNS_SRC_B1		EXTI_PinSource1
#define BTNS_SRC_B2		EXTI_PinSource2

//SDADC
#define ADC_ANALOGPWR			PWR_SDADCAnalog_3
#define ADC_SDADCPERIPHCLK		RCC_APB2Periph_SDADC3
#define ADC_GPIOPERIPHCLK		RCC_AHBPeriph_GPIOD
#define ADC_POTMETVOLTAGE_PORT	GPIOD
#define ADC_POTMETVOLTAGE_PIN	GPIO_Pin_8
#define ADC_ADC					SDADC3
#define ADC_ADCCHANNEL			SDADC_Channel_6
#define ADC_RESOLUTION			0xFFFF
#define ADC_VREF				(double)3300

//voltage divider before SDADC input
//divider Vin=<-4.85; 5.14>V, Vadc=<0; 3.3>V
#define ADC_R1		(double)10000
#define ADC_R2		(double)15000
#define ADC_R3 		(double)30000

//channel selection
#define POTMET_CHANNEL_PORT				GPIOB
#define POTMET_CHANNELPORT_PERIPHCLOCK	RCC_AHBPeriph_GPIOB
#define POTMET_CHANNEL1					GPIO_Pin_9
#define POTMET_CHANNEL2					GPIO_Pin_8
#define POTMET_CHANNEL3					GPIO_Pin_7
#define POTMET_CHANNEL4					GPIO_Pin_6
#define POTMET_CHANNELPINS				POTMET_CHANNEL1 | POTMET_CHANNEL2 | POTMET_CHANNEL3 | POTMET_CHANNEL4

//syndet definitions
#define SYNDET_PORT				( GPIOA )
#define SYNDET_PORT_PERIPHCLK	( RCC_AHBPeriph_GPIOA )
#define SYNDET_PIN_FM			( GPIO_Pin_0 )
#define SYNDET_PIN_SD1			( GPIO_Pin_1 )
#define SYNDET_PIN_SD2			( GPIO_Pin_2 )
#define SYNDET_PINS				( SYNDET_PIN_FM | SYNDET_PIN_SD1 | SYNDET_PIN_SD2 )

#endif	//main_h
