/*
*Filename: scheduler.h
*Author: Stanislav Subrt
*Year: 2013
*/

#ifndef SCHEDULER_H
#define SCHEDULER_H


#define SCHEDULER_BUFFER_FULL	-1
#define SCHEDULER_OK			-2
#define SCHEDULER_UNDEF_BUFFER	-3
#define SCHEDULER_BUFFER_EMPTY	-4


typedef struct {
    void (**FnQueue)(void);     //pointer to pointer  to function with parameter void returning void aka queue of functions to call
    int FnQueueSize;
    int HeadIndex;
	int TailIndex;
	int ToDo;

} SchedulerStructTypedef;


extern void scheduler_Init(SchedulerStructTypedef *s, void (**fnQueue)(void), int fnQueueSize);
extern int scheduler_Add(SchedulerStructTypedef *s, void (*f)(void));
extern int scheduler_Advance(SchedulerStructTypedef *s);


#endif  //end of SCHEDULER_H
