// Header:
// File Name:						main.c
// File Description:
// Author:							Stanislav Subrt
// Date:								2013
// Todo:
// Notes:

#include "main.h"



char ScrBuf[1024];


void Init(void){
	char welcomemsg[]="MCU successfully initialized and connected!\r\n";
	volatile int i;

	//initialize interrupts
	NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);		//place vector table into the ram
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);		//configure interrupt preemption and priority possibilities

	//initialize modules
	comm_Init();
	pm_Init();
	sd_Init();
	adc_Init();
	gui_Init();

	//clear screen, send welcomemsg via usart and remove everything from button event queue
	lcd_Fill(ScrBuf, 0);
	lcd_UpdateScreen(ScrBuf);
	comm_SendData(welcomemsg, sizeof(welcomemsg));
	for( i=0; i< 360000; i++);
	btns_ClearQueue();
}


int main(void){
	Init();										//initialize peripherals and modules

	while(1){
		gui_HandleRefreshRequests();			//handle gui events
		comm_HandleReceivedData();			//Handle usart events
		pm_InvokeCallbacks();				//handle potmet events
	}
}
