/*
*Filename: myleds.c
*Author: Stanislav Subrt
*Year: 2013
*/

#include "myleds.h"
#include "stm32f37x.h"

/*
#define MYLEDS_LED1PIN			GPIO_Pin_8
#define MYLEDS_LED2PIN			GPIO_Pin_9
#define MYLEDS_ALLPINS			(GPIO_Pin_8 | GPIO_Pin_9)
#define MYLEDS_PORT				GPIOE
#define MYLEDS_PORTPERIPHCLK	RCC_AHBPeriph_GPIOE
*/
void myleds_Init(void){
	GPIO_InitTypeDef	GPIO_InitStructure;

	RCC_AHBPeriphClockCmd(MYLEDS_PORTPERIPHCLK, ENABLE);

	GPIO_InitStructure.GPIO_Pin  = MYLEDS_ALLPINS;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(MYLEDS_PORT, &GPIO_InitStructure);

	myleds_SetLED(MYLEDS_LED1PIN);		//turn on LED1 which indicates if device is running (that does NOT mean measurement is runing, just power is on)
}


void myleds_ToggleLED(unsigned lEDxPin){
	unsigned Status = GPIO_ReadOutputData(MYLEDS_PORT);
	Status ^= lEDxPin;	//toggle ledxBit;
	GPIO_Write(MYLEDS_PORT, Status);
}


void myleds_SetLED(unsigned lEDxPin){
	GPIO_WriteBit(MYLEDS_PORT, lEDxPin, 1);
}


void myleds_ClearLED(unsigned lEDxPin){
	GPIO_WriteBit(MYLEDS_PORT, lEDxPin, 0);
}

