/*
*Filename: scheduler.c
*Author: Stanislav Subrt
*Year: 2013
*/

#include "scheduler.h"



void scheduler_Init(SchedulerStructTypedef *s, void (**fnQueue)(void), int fnQueueSize){

    s->FnQueue = fnQueue;
	s->FnQueueSize = fnQueueSize;
    s->HeadIndex = 0;
	s->TailIndex = 0;
	s->ToDo = 0;

}


int scheduler_Add(SchedulerStructTypedef *s, void (*f)(void)){

	if( (s->HeadIndex) < (s->FnQueueSize) ){	//if there is space in queue
		s->FnQueue[s->HeadIndex] = f;				//save pointer to function to a free space
		s->HeadIndex++;								//increment pointer to a next free space
		s->ToDo++;									//increment number of todos
		return SCHEDULER_OK;
	}
	else{
		return SCHEDULER_BUFFER_FULL;
	}

}

int scheduler_Advance(SchedulerStructTypedef *s){

	if( s->ToDo != 0 ){		//if there is function in queue
		s->FnQueue[s->TailIndex]();
		s->ToDo--;
		s->TailIndex++;
		return SCHEDULER_OK;
	}
	else{
		s->HeadIndex = 0;
		s->TailIndex = 0;
		s->ToDo = 0;
		return SCHEDULER_BUFFER_EMPTY;
	}

}
